#!/usr/bin/python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008 by Victor J. Chamorro                              *
#*   ministropepon@esdebian.org                                            *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation, version 2 of the License                *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

import sys
from PyQt4 import QtCore, QtGui
#import PyQt4
#from PyQt4 import *

class Campos(object):

	def __init__(self, conn):
		self.dbconn = conn
		return

	def llenaddlGenero(self, campo, tipo='ddl'):
		sql = "SELECT id, nombre from generos where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		campo.clear()
		if (tipo == 'ddl'):
			campo.insertItem(0,"",QtCore.QVariant(""))
		self.generos = {}
		self.generos_pos = {}
		self.generos_count = {}
		self.generos_id = {}
		i=1
		for genero in rs:
			self.generos[genero[0]] = genero[1]
			self.generos_count[genero[0]] = 0
			self.generos_pos[i]=genero[0]
			self.generos_id[genero[0]] = i
			if (tipo == 'ddl'):
				campo.insertItem(i,genero[1],QtCore.QVariant(genero[1]))
			if (tipo == 'lst'):
				campo.insertItem(i,genero[1])
			i=i+1
		return

	def llenaddlTipo(self, campo, gtipo='ddl'):
		sql = "SELECT id, nombre from tipos where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		campo.clear()
		if (gtipo == 'ddl'):
			campo.insertItem(0,"")
		self.tipos = {}
		self.tipos_pos = {}
		self.tipos_count = {}
		self.tipos_id = {}
		i=1
		for tipo in rs:
			self.tipos[tipo[0]]=tipo[1]
			self.tipos_id[tipo[0]] = i
			self.tipos_count[tipo[0]] = 0
			self.tipos_pos[i] = tipo[0]
			if (gtipo == 'ddl'):
				campo.insertItem(i,tipo[1],QtCore.QVariant(tipo[1]))
			if (gtipo == 'lst'):
				campo.insertItem(i,tipo[1])
			i=i+1
		return

	def llenaddlFormato(self, campo, tipo='ddl'):
		sql = "SELECT id, nombre from formatos where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		campo.clear()
		if (tipo == 'ddl'):
			campo.insertItem(0,"")
		self.formatos={}
		self.formatos_pos = {}
		self.formatos_count = {}
		self.formatos_id = {}
		i=1
		for formato in rs:
			self.formatos[formato[0]] = formato[1]
			self.formatos_id[formato[0]] = i
			self.formatos_count[formato[0]] = 0
			self.formatos_pos[i] = formato[0]
			if (tipo == 'ddl'):
				campo.insertItem(i,formato[1],QtCore.QVariant(formato[0]))
			if (tipo == 'lst'):
				campo.insertItem(i,formato[1])
			i=i+1
		return

	def llenaddlAnio(self, campo):
		sql = "SELECT distinct anio from peliculas where borrado = 0 order by anio asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		campo.clear()
		campo.insertItem(0,"")
		self.anios=[]
		self.anios_count={}
		i=1
		for anio in rs:
			self.anios.append(anio[0])			
			campo.insertItem(i,anio[0])
			self.anios_count[anio[0]] = 0
			i=i+1
		
		return

	def llenaddlLocalizacion(self, campo, tipo='ddl'):
		sql = "SELECT * from localizaciones where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		campo.clear()
		if (tipo == 'ddl'):
			campo.insertItem(0,"")
		self.localizaciones={}
		self.localizaciones_pos = {}
		self.localizaciones_count = {}
		self.localizaciones_id = {}
		i=1
		for localizacion in rs:
			self.localizaciones[localizacion[0]] = localizacion[1]
			self.localizaciones_id[localizacion[0]]=i
			self.localizaciones_count[localizacion[0]] = 0
			self.localizaciones_pos[i] = localizacion[0]
			if (tipo == 'ddl'):
				campo.insertItem(i,localizacion[1], QtCore.QVariant(localizacion[0]))
			if (tipo == 'lst'):
				campo.insertItem(i,localizacion[1])
			i=i+1
		return

	def llenaddlValoracion(self, campo):
		campo.clear()
		campo.setIconSize(QtCore.QSize(100, 17))
		campo.setObjectName("ddlValoracion")
		campo.addItem(QtCore.QString())
		campo.setItemText(0, "")
		campo.addItem(QtCore.QString())
		icon1 = QtGui.QIcon()
		icon1.addPixmap(QtGui.QPixmap("./themes/default/stars/estrella.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		campo.addItem(icon1, QtCore.QString())
		icon2 = QtGui.QIcon()
		icon2.addPixmap(QtGui.QPixmap("./themes/default/stars/estrella2.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		campo.addItem(icon2, QtCore.QString())
		icon3 = QtGui.QIcon()
		icon3.addPixmap(QtGui.QPixmap("./themes/default/stars/estrella3.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		campo.addItem(icon3, QtCore.QString())
		icon4 = QtGui.QIcon()
		icon4.addPixmap(QtGui.QPixmap("./themes/default/stars/estrella4.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		campo.addItem(icon4, QtCore.QString())
		icon5 = QtGui.QIcon()
		icon5.addPixmap(QtGui.QPixmap("./themes/default/stars/estrella5.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		campo.addItem(icon5, QtCore.QString())

		campo.setItemText(1, "0")
		campo.setItemText(2, "1")
		campo.setItemText(3, "2")
		campo.setItemText(4, "3")
		campo.setItemText(5, "4")
		campo.setItemText(6, "5")

	def InsertaIcono(self, campo, nombre):
		icon = QtGui.QIcon()
		icon.addPixmap(QtGui.QPixmap("./themes/default/16x16/" + nombre + ".png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		campo.setIcon(icon)
		