# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008 by Victor J. Chamorro                              *
#*   ministropepon@esdebian.org                                            *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation, version 2 of the License                *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

#		Importaciones de librerías

# Sistema
import sys
import base64
import shutil #para el copy

# librerias de QT4
from PyQt4 import *

# Propias
from configuracion import *
from campos import *

#		Importaciones de Formularios

from frmsmoviedb import *
from preferencias import *
from insertar import *
from about import *
from confinicial import *

#		Globales

version = "2.0.dev1"

class frmMovie(QtGui.QMainWindow):


	def __init__(self, parent=None):
		QtGui.QWidget.__init__(self, parent)
		self.ui = Ui_frmsmoviedb()
		self.ui.setupUi(self)
		self.conf = configuracion()
		if (self.conf.LeeConfiguracion('dbtype')==''):
			self.asistenteConfInicial()

		#Restaurar el estado de los elementos ocultos

		if (self.conf.LeeConfiguracion('toolbar', 'vista') != ''):
			self.ui.Toolbar.setHidden(not int(self.conf.LeeConfiguracion('toolbar', 'vista')))
			self.ui.verBarra_de_HerramientasAction.setChecked(int(self.conf.LeeConfiguracion('toolbar', 'vista')))
		if (self.conf.LeeConfiguracion('search','vista') != ''):
			self.ui.groupBox1.setHidden(not int(self.conf.LeeConfiguracion('search','vista')))
			self.ui.verBsquedaAction.setChecked(int(self.conf.LeeConfiguracion('search','vista')))
		if (self.conf.LeeConfiguracion('catalog', 'vista') != ''):
			self.ui.treeWidget.setHidden(not int(self.conf.LeeConfiguracion('catalog', 'vista')))
			self.ui.verCatlogoAction.setChecked(int(self.conf.LeeConfiguracion('catalog', 'vista')))
		if (self.conf.LeeConfiguracion('buttons', 'vista') != ''):
			self.ui.fraBotonesRapidos.setHidden(not int(self.conf.LeeConfiguracion('buttons', 'vista')))
			self.ui.verAcciones_RpidasAction.setChecked(int(self.conf.LeeConfiguracion('buttons', 'vista')))
		self.iniciaArbolCatalogo()

		self.conectores()
		#self.pintaTablaCatalogo()

	def conectores(self):
		QtCore.QObject.connect(self.ui.tableWidget, QtCore.SIGNAL("cellDoubleClicked (int,int)"), self.tbResultados_onclick)

	def iniciaArbolCatalogo(self):

		self.estrella1 = QtGui.QIcon()
		self.estrella1.addPixmap(QtGui.QPixmap("./themes/default/stars/estrella.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		self.estrella2 = QtGui.QIcon()
		self.estrella2.addPixmap(QtGui.QPixmap("./themes/default/stars/estrella2.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		self.estrella3 = QtGui.QIcon()
		self.estrella3.addPixmap(QtGui.QPixmap("./themes/default/stars/estrella3.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		self.estrella4 = QtGui.QIcon()
		self.estrella4.addPixmap(QtGui.QPixmap("./themes/default/stars/estrella4.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		self.estrella5 = QtGui.QIcon()
		self.estrella5.addPixmap(QtGui.QPixmap("./themes/default/stars/estrella5.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		self.icon11 = QtGui.QIcon()
		self.icon11.addPixmap(QtGui.QPixmap("./themes/default/16x16/folder_rollo.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		self.icon10 = QtGui.QIcon()
		self.icon10.addPixmap(QtGui.QPixmap("./themes/default/16x16/rollo.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
		
		self.ui.treeWidget.clear()

		#Padre
		item = QtGui.QTreeWidgetItem(self.ui.treeWidget)
		item.setIcon(0, self.icon10)

		#Año
		item2 = QtGui.QTreeWidgetItem(item)
		item2.setIcon(0, self.icon11)
		#pendiente: agregar dinamicamente

		#formatos
		item2 = QtGui.QTreeWidgetItem(item)
		item2.setIcon(0, self.icon11)
		#pendiente: agregar dinamicamente

		#Generos
		item3 = QtGui.QTreeWidgetItem(item)
		item3.setIcon(0, self.icon11)

		#Localizaciones
		item3 = QtGui.QTreeWidgetItem(item)
		item3.setIcon(0, self.icon11)

		#Tipos
		item3 = QtGui.QTreeWidgetItem(item)
		item3.setIcon(0, self.icon11)

		#valoraciones
		item_val = QtGui.QTreeWidgetItem(item)
		item_val.setIcon(0, self.icon11)
		#6 niveles, 0 - 5 estrellas
		item = QtGui.QTreeWidgetItem(item_val)
		item = QtGui.QTreeWidgetItem(item_val)
		item.setIcon(0, self.estrella1)
		item = QtGui.QTreeWidgetItem(item_val)
		item.setIcon(0, self.estrella2)
		item = QtGui.QTreeWidgetItem(item_val)
		item.setIcon(0, self.estrella3)
		item = QtGui.QTreeWidgetItem(item_val)
		item.setIcon(0, self.estrella4)
		item = QtGui.QTreeWidgetItem(item_val)
		item.setIcon(0, self.estrella5)

		self.ui.treeWidget.headerItem().setText(0, QtGui.QApplication.translate("frmsmoviedb", "Catálogo", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.headerItem().setText(1, QtGui.QApplication.translate("frmsmoviedb", "Películas", None, QtGui.QApplication.UnicodeUTF8))
		__sortingEnabled = self.ui.treeWidget.isSortingEnabled()
		self.ui.treeWidget.setSortingEnabled(False)
		self.ui.treeWidget.topLevelItem(0).setText(0, QtGui.QApplication.translate("frmsmoviedb", "Todo", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).setText(1, QtGui.QApplication.translate("frmsmoviedb", "0", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(0).setText(0, QtGui.QApplication.translate("frmsmoviedb", "Años", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(1).setText(0, QtGui.QApplication.translate("frmsmoviedb", "Formatos", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(2).setText(0, QtGui.QApplication.translate("frmsmoviedb", "Géneros", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(3).setText(0, QtGui.QApplication.translate("frmsmoviedb", "Localizaciones", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(4).setText(0, QtGui.QApplication.translate("frmsmoviedb", "Tipos", None, QtGui.QApplication.UnicodeUTF8))
		
		self.ui.treeWidget.topLevelItem(0).child(5).setText(0, QtGui.QApplication.translate("frmsmoviedb", "Valoraciones", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(0).setText(0, QtGui.QApplication.translate("frmsmoviedb", "0", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(0).setText(1, QtGui.QApplication.translate("frmsmoviedb", "0", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(1).setText(0, QtGui.QApplication.translate("frmsmoviedb", "1", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(1).setText(1, QtGui.QApplication.translate("frmsmoviedb", "0", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(2).setText(0, QtGui.QApplication.translate("frmsmoviedb", "2", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(2).setText(1, QtGui.QApplication.translate("frmsmoviedb", "0", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(3).setText(0, QtGui.QApplication.translate("frmsmoviedb", "3", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(3).setText(1, QtGui.QApplication.translate("frmsmoviedb", "0", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(4).setText(0, QtGui.QApplication.translate("frmsmoviedb", "4", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(4).setText(1, QtGui.QApplication.translate("frmsmoviedb", "0", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(5).setText(0, QtGui.QApplication.translate("frmsmoviedb", "5", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.topLevelItem(0).child(5).child(5).setText(1, QtGui.QApplication.translate("frmsmoviedb", "0", None, QtGui.QApplication.UnicodeUTF8))
		self.ui.treeWidget.setSortingEnabled(__sortingEnabled)


	def pintaTablaCatalogo(self, busca=1):

		

		#Establecemos una altura a las filas
		self.ui.tableWidget.verticalHeader().setDefaultSectionSize(110);

		self.ui.tableWidget.clearContents()
		self.ui.tableWidget.setRowCount(1)
		self.ui.tableWidget.setColumnCount(9)
		self.ui.tableWidget.setIconSize(QtCore.QSize(100, 100))


		#Cabeceras
		self.ui.tableWidget.setHorizontalHeaderItem(0,QtGui.QTableWidgetItem(QtGui.QApplication.translate("frmsmoviedb", "Carátula", None, QtGui.QApplication.UnicodeUTF8)))
		self.ui.tableWidget.setHorizontalHeaderItem(1,QtGui.QTableWidgetItem(QtGui.QApplication.translate("frmsmoviedb", "Nombre", None, QtGui.QApplication.UnicodeUTF8)))
		self.ui.tableWidget.setHorizontalHeaderItem(2,QtGui.QTableWidgetItem(QtGui.QApplication.translate("frmsmoviedb", "Género", None, QtGui.QApplication.UnicodeUTF8)))
		self.ui.tableWidget.setHorizontalHeaderItem(3,QtGui.QTableWidgetItem(QtGui.QApplication.translate("frmsmoviedb", "Tipo", None, QtGui.QApplication.UnicodeUTF8)))
		self.ui.tableWidget.setHorizontalHeaderItem(4,QtGui.QTableWidgetItem(QtGui.QApplication.translate("frmsmoviedb", "Formato", None, QtGui.QApplication.UnicodeUTF8)))
		self.ui.tableWidget.setHorizontalHeaderItem(5,QtGui.QTableWidgetItem(QtGui.QApplication.translate("frmsmoviedb", "Año", None, QtGui.QApplication.UnicodeUTF8)))
		self.ui.tableWidget.setHorizontalHeaderItem(6,QtGui.QTableWidgetItem(QtGui.QApplication.translate("frmsmoviedb", "Tamaño", None, QtGui.QApplication.UnicodeUTF8)))
		self.ui.tableWidget.setHorizontalHeaderItem(7,QtGui.QTableWidgetItem(QtGui.QApplication.translate("frmsmoviedb", "Localización", None, QtGui.QApplication.UnicodeUTF8)))
		self.ui.tableWidget.setHorizontalHeaderItem(8,QtGui.QTableWidgetItem(QtGui.QApplication.translate("frmsmoviedb", "Valoración", None, QtGui.QApplication.UnicodeUTF8)))
		self.ui.tableWidget.setSortingEnabled(False)

		##		Carátula
		#caratula= QtGui.QPixmap()
		

		#item = QtGui.QTableWidgetItem()

		#item.setSizeHint(QtCore.QSize(100,100))

		#item.setIcon( QtGui.QIcon(caratula))
		#self.ui.tableWidget.setItem(0, 0, item)
		#self.ui.tableWidget.row(item).setFixedHeight=100
		#self.ui.tableWidget.row(item).setSizeHint(QtCore.QSize(100,100))


		sql = "SELECT id, nombre, genero, tipo, formato, anio, tamanio, localizacion, valoracion\
		 from peliculas where borrado = 0"


		if busca==1:
			#WHERE
			if self.ui.txtNombre.text().length() > 0:
				sql = sql+" AND nombre like '%"+self.codifica(self.ui.txtNombre.text())+"%'"
			if self.ui.ddlGenero.currentIndex() > 0:
				sql = sql+" AND genero = "+str(self.campos.generos_pos[self.ui.ddlGenero.currentIndex()])
			if self.ui.ddlTipo.currentIndex() > 0:
				sql = sql+" AND tipo = "+str(self.campos.tipos_pos[self.ui.ddlTipo.currentIndex()])
			if self.ui.ddlFormato.currentIndex() > 0:
				sql = sql+" AND formato	 = "+str(self.campos.formatos_pos[self.ui.ddlFormato.currentIndex()])
			if self.ui.ddlLocalizacion.currentIndex() > 0:
				sql = sql+" AND localizacion = "+str(self.campos.localizaciones_pos[self.ui.ddlLocalizacion.currentIndex()])
			if self.ui.ddlAnio.currentIndex() > 0:
				sql = sql+" AND anio = '"+self.codifica(self.ui.ddlAnio.currentText())+"'"
			if self.ui.ddlValoracion.currentIndex() > 0:
				sql = sql+" AND valoracion = '"+str(self.ui.ddlValoracion.currentIndex()-1)+"'"
		else:
			#Bug 2464539, al insertar o eliminar una película se descuadraban los contadores
			#Si no buscamos, restablecemos los contadores:
			for genero in self.campos.generos_count: self.campos.generos_count[genero]=0
			for tipo in self.campos.tipos_count: self.campos.tipos_count[tipo]=0
			for formato in self.campos.formatos_count: self.campos.formatos_count[formato]=0
			for localizacion in self.campos.localizaciones_count: self.campos.localizaciones_count[localizacion]=0
			for anio in self.campos.anios_count: self.campos.anios_count[anio]=0

			#Para que refresque los años por si hay modificados o nuevos.
			self.campos.llenaddlAnio(self.ui.ddlAnio)

		#Orden
		sql = sql+" ORDER BY nombre ASC"

		#print sql
		try:
			self.dbconn.execute(str(sql))
		except:
			self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
			QtGui.QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al ejecutar la búsqueda'))
			print sql			
			return

		rs = self.dbconn.fetchall()
		self.peliculas = {}
		self.campos.valoraciones_count={}
		self.campos.valoraciones_count[0]=0
		self.campos.valoraciones_count[1]=0
		self.campos.valoraciones_count[2]=0
		self.campos.valoraciones_count[3]=0
		self.campos.valoraciones_count[4]=0
		self.campos.valoraciones_count[5]=0

		rows = 0
		print sql

		for pelicula in rs:

			self.peliculas[rows] = pelicula[0]

			#Genero
			try:
				genero = self.campos.generos[pelicula[2]]
				try:
					self.campos.generos_count[pelicula[2]] = self.campos.generos_count[pelicula[2]]+1
				except: nada = 0
			except:
				genero = 'No encontrado'

			#Tipo
			try:
				tipo = self.campos.tipos[pelicula[3]]
				try:
					self.campos.tipos_count[pelicula[3]] = self.campos.tipos_count[pelicula[3]]+1
				except: nada = 0
			except:
				tipo = 'No encontrado'

			#Formato
			try:
				formato = self.campos.formatos[pelicula[4]]
				try:
					self.campos.formatos_count[pelicula[4]] = self.campos.formatos_count[pelicula[4]]+1
				except: nada = 0
			except:
				formato = 'No encontrado'

			#localizacion
			try:
				localizacion = self.campos.localizaciones[pelicula[7]]
				try:
					self.campos.localizaciones_count[pelicula[7]] = self.campos.localizaciones_count[pelicula[7]]+1
				except: nada = 0
			except:
				localizacion = 'No encontrado'

			#Valoracion
			item_valoracion = QtGui.QTableWidgetItem()

			try:

				if(pelicula[8] == 0):
					self.campos.valoraciones_count[0]=self.campos.valoraciones_count[0]+1
				if(pelicula[8] == 1):
					item_valoracion.setIcon(self.estrella1)
					self.campos.valoraciones_count[1]=self.campos.valoraciones_count[1]+1
				if(pelicula[8] == 2):
					item_valoracion.setIcon(self.estrella2)
					self.campos.valoraciones_count[2]=self.campos.valoraciones_count[2]+1
				if(pelicula[8] == 3):
					item_valoracion.setIcon(self.estrella3)
					self.campos.valoraciones_count[3]=self.campos.valoraciones_count[3]+1
				if(pelicula[8] == 4):
					item_valoracion.setIcon(self.estrella4)
					self.campos.valoraciones_count[4]=self.campos.valoraciones_count[4]+1
				if(pelicula[8] == 5):
					item_valoracion.setIcon(self.estrella5)
					self.campos.valoraciones_count[5]=self.campos.valoraciones_count[5]+1

			except:
				print "Valoracion no encontrada "+str(pelicula[8])

			#Anio
			try:
				try:
					self.campos.anios_count[pelicula[5]] = self.campos.anios_count[pelicula[5]]+1
				except:
					self.campos.anios_count[pelicula[5]] = 1
			except: 
				print "Fallo al incrementar los contadores de anio"
				print pelicula[5]				

			#Lo asociamos a la tabla

			self.ui.tableWidget.setRowCount(rows+1)



			
			#		Carátula

			

			sql = "Select datos from caratulas where id_pelicula = "+str(pelicula[0])
			caratula_data = ''
			try:
				self.dbconn.execute(str(sql))
				rs_caratula = self.dbconn.fetchall()
				for tmp in rs_caratula:
					caratula_data = tmp[0]
			except:
				QtGui.QMessageBox.critical(self,'sMovieDB - Error','Error al buscar la carátula')
				print sql
				return

			
			
			try:
				if (caratula_data != ''):
					caratula= QtGui.QPixmap()
					caratula.loadFromData(base64.b64decode(caratula_data),"JPEG")

					item = QtGui.QTableWidgetItem()

					item.setSizeHint(QtCore.QSize(100,100))

					item.setIcon( QtGui.QIcon(caratula))
					#item.setFlags(QtCore.Qt.ItemIsSelectable)

					item.setSizeHint(QtCore.QSize(100,100))
					self.ui.tableWidget.setItem(rows, 0, item)
				else:
					self.ui.tableWidget.setItem(rows, 0, QtGui.QTableWidgetItem())

			except:
				QtGui.QMessageBox.critical(self,'sMovieDB - Error','Error al pintar la carátula')
				return

			#Titulo
			self.ui.tableWidget.setItem(rows, 1, QtGui.QTableWidgetItem(pelicula[1]))
			
			#Genero
			self.ui.tableWidget.setItem(rows,2, QtGui.QTableWidgetItem(genero))
			#Tipo
			self.ui.tableWidget.setItem(rows,3, QtGui.QTableWidgetItem(tipo))
			#formato
			self.ui.tableWidget.setItem(rows,4, QtGui.QTableWidgetItem(formato))
			#Anio
			self.ui.tableWidget.setItem(rows,5, QtGui.QTableWidgetItem(pelicula[5]))
			#tamanio
			self.ui.tableWidget.setItem(rows,6, QtGui.QTableWidgetItem(pelicula[6]))
			#localizacion
			self.ui.tableWidget.setItem(rows,7, QtGui.QTableWidgetItem(localizacion))
			#Valoración
			self.ui.tableWidget.setItem(rows,8, QtGui.QTableWidgetItem(item_valoracion))

			#Celdas como solo lectura
			self.ui.tableWidget.item(rows, 0).setFlags(QtCore.Qt.ItemIsEnabled)
			self.ui.tableWidget.item(rows, 1).setFlags(QtCore.Qt.ItemIsEnabled)
			self.ui.tableWidget.item(rows, 2).setFlags(QtCore.Qt.ItemIsEnabled)
			self.ui.tableWidget.item(rows, 3).setFlags(QtCore.Qt.ItemIsEnabled)
			self.ui.tableWidget.item(rows, 4).setFlags(QtCore.Qt.ItemIsEnabled)
			self.ui.tableWidget.item(rows, 5).setFlags(QtCore.Qt.ItemIsEnabled)
			self.ui.tableWidget.item(rows, 6).setFlags(QtCore.Qt.ItemIsEnabled)
			self.ui.tableWidget.item(rows, 7).setFlags(QtCore.Qt.ItemIsEnabled)
			self.ui.tableWidget.item(rows, 8).setFlags(QtCore.Qt.ItemIsEnabled)

			

			rows=rows+1


		#Tabla como solo lectura
		#self.ui.tableWidget.setReadOnly(1)

		return

	def pintaArbolCatalogo(self):
		
		self.iniciaArbolCatalogo()

		#Todo
		self.ui.treeWidget.topLevelItem(0).setText(1, str(len(self.peliculas)))
		self.ui.treeWidget.topLevelItem(0).setExpanded(1)
		
		#Años		
		item_anios = self.ui.treeWidget.topLevelItem(0).child(0)
		item_anios.setExpanded(0) #cerrado
		i=0
		for anio in self.campos.anios:
			item_a = QtGui.QTreeWidgetItem(item_anios)
			item_a.setText(0,str(anio))
			item_a.setText(1,str(self.campos.anios_count[anio]))
			item_a.setText(2,str(i))
			item_a.setText(3,"anio")
			i=i+1

		#Formatos
		item_formatos = self.ui.treeWidget.topLevelItem(0).child(1)
		item_formatos.setExpanded(0)
		for formato in self.campos.formatos:
			item_f = QtGui.QTreeWidgetItem(item_formatos)
			item_f.setText(0,self.campos.formatos[formato])
			item_f.setText(1,str(self.campos.formatos_count[formato]))
			item_f.setText(2,str(formato))
			item_f.setText(3,"formato")

		#Generos
		item_generos = self.ui.treeWidget.topLevelItem(0).child(2)
		item_generos.setExpanded(1)
		for genero in self.campos.generos:
			item_g = QtGui.QTreeWidgetItem(item_generos)
			item_g.setText(0,self.campos.generos[genero])
			item_g.setText(1,str(self.campos.generos_count[genero]))
			item_g.setText(2,str(genero))
			item_g.setText(3,"genero")

		#Localizaciones
		item_localizaciones = self.ui.treeWidget.topLevelItem(0).child(3)
		item_localizaciones.setExpanded(0)
		for localizacion in self.campos.localizaciones:
			item_l = QtGui.QTreeWidgetItem(item_localizaciones)
			item_l.setText(0,self.campos.localizaciones[localizacion])
			item_l.setText(1,str(self.campos.localizaciones_count[localizacion]))
			item_l.setText(2,str(localizacion))
			item_l.setText(3,"localizacion")

		#Tipos
		item_tipos = self.ui.treeWidget.topLevelItem(0).child(4)
		item_tipos.setExpanded(0)
		for tipo in self.campos.tipos:
			item_t = QtGui.QTreeWidgetItem(item_tipos)
			item_t.setText(0,self.campos.tipos[tipo])
			item_t.setText(1,str(self.campos.tipos_count[tipo]))
			item_t.setText(2,str(tipo))
			item_t.setText(3,"tipo")


		# 0 estrellas
		self.ui.treeWidget.topLevelItem(0).child(5).child(0).setText(1, str(self.campos.valoraciones_count[0]))
		self.ui.treeWidget.topLevelItem(0).child(5).child(0).setText(3, "valoracion")
		
		# 1 estrella
		self.ui.treeWidget.topLevelItem(0).child(5).child(1).setText(1, str(self.campos.valoraciones_count[1]))
		self.ui.treeWidget.topLevelItem(0).child(5).child(1).setText(3, "valoracion")

		# 2 estrellas
		self.ui.treeWidget.topLevelItem(0).child(5).child(2).setText(1, str(self.campos.valoraciones_count[2]))
		self.ui.treeWidget.topLevelItem(0).child(5).child(2).setText(3, "valoracion")

		# 3 estrellas
		self.ui.treeWidget.topLevelItem(0).child(5).child(3).setText(1, str(self.campos.valoraciones_count[3]))
		self.ui.treeWidget.topLevelItem(0).child(5).child(3).setText(3, "valoracion")

		# 4 estrellas
		self.ui.treeWidget.topLevelItem(0).child(5).child(4).setText(1, str(self.campos.valoraciones_count[4]))
		self.ui.treeWidget.topLevelItem(0).child(5).child(4).setText(3, "valoracion")

		# 5 estrellas
		self.ui.treeWidget.topLevelItem(0).child(5).child(5).setText(1, str(self.campos.valoraciones_count[5]))
		self.ui.treeWidget.topLevelItem(0).child(5).child(5).setText(3, "valoracion")

		
		return

	def conectar(self):


		self.setCursor(QtGui.QCursor(QtCore.Qt.WaitCursor))

		self.dbtype='sqlite'	# por defecto usamos SQLite

		if (self.conf.LeeConfiguracion('dbtype') == 'mysql'):

			# MySQL

			try:
				try: import MySQLdb
				except ImportError: import mysql.connector as MySQLdb	#mysql.connector para Windows

			except:
				QtGui.QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo cargar la extensión MySQL. Compruebe que esta instalado el paquete python-mysqldb"))
				self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
				return

			try:
				try: self.db = MySQLdb.connect(host=self.conf.LeeConfiguracion('host'),user=self.conf.LeeConfiguracion('user'),passwd=self.conf.LeeConfiguracion('pass'),db=self.conf.LeeConfiguracion('dbname'))
				except: self.db = MySQLdb.connect(host=self.conf.LeeConfiguracion('host'),user=self.conf.LeeConfiguracion('user'),password=self.conf.LeeConfiguracion('pass'),database=self.conf.LeeConfiguracion('dbname'),charset='latin1',use_unicode=False,get_warnings=False)
			except:
				print "error al conectar"
				QtGui.QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo conectar con la base de datos,\nrevise las preferencias"))
				self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
				return

			self.dbtype='mysql'


		if (self.dbtype=='sqlite'):

			# Sqlite
			try:

				try: import sqlite3 as dbapi
				except ImportError: from pysqlite2 import dbapi2 as dbapi


			except:
				QtGui.QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo cargar la extensión SQLlite."))
				self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
				return

			try:
				self.db = dbapi.connect(os.environ["HOME"] + "/.smoviedb/smoviedb.dat")
			except:
				print "error al conectar"
				QtGui.QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo conectar con la base de datos"))
				self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
				return

			self.dbtype='sqlite'

		#try:
		self.conectado = 1
		self.dbconn = self.db.cursor()
		print "conectado"
		self.campos = Campos(self.dbconn)
		self.campos.llenaddlGenero(self.ui.ddlGenero)
		self.campos.llenaddlTipo(self.ui.ddlTipo)
		self.campos.llenaddlFormato(self.ui.ddlFormato)
		self.campos.llenaddlAnio(self.ui.ddlAnio)
		self.campos.llenaddlLocalizacion(self.ui.ddlLocalizacion)
		self.campos.llenaddlValoracion(self.ui.ddlValoracion)
		
		self.poneddlBusquedaBlanco()
		self.pintaTablaCatalogo(0)

		self.pintaArbolCatalogo()

		self.ui.btnInsertar.setEnabled(1)
		self.ui.accionInsertar.setEnabled(1)
		self.ui.tableWidget.setEnabled(1)
		self.ui.treeWidget.setEnabled(1)
		self.ui.btnConectar.setText(self.__tr('Re-&conectar'))
		self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
		return


	def buscar(self):
		if self.conectado!=0:
			self.setCursor(QtGui.QCursor(QtCore.Qt.WaitCursor))
			self.pintaTablaCatalogo()
			self.setCursor(QtGui.QCursor(QtCore.Qt.ArrowCursor))
		else:
			QtGui.QMessageBox.information(self,self.__tr('sMovieDB - Información'), self.__tr('Debe estar conectado para poder buscar'))



	def insertar(self):
		self.frm_insertar = insertar()
		self.frm_insertar.dbconn = self.dbconn
		self.frm_insertar.db = self.db
		self.frm_insertar.llenar(self)
		return

	

	def preferencias(self):
		self.frm_preferencias = preferencias()
		self.frm_preferencias.onload(self)
	
	def poneddlBusquedaBlanco(self):
		self.ui.txtNombre.setText("")
		self.ui.ddlGenero.setCurrentIndex(0)
		self.ui.ddlTipo.setCurrentIndex(0)
		self.ui.ddlFormato.setCurrentIndex(0)
		self.ui.ddlLocalizacion.setCurrentIndex(0)
		self.ui.ddlValoracion.setCurrentIndex(0)
		self.ui.ddlAnio.setCurrentIndex(0)
		return

	def ArbolCatalogo_click(self,item,a):
		#print item.text(3)
		#print item.text(0)
		
		#try:

		#print "Pulsado "+str(QListViewItem.text(3))+" id "+str(QListViewItem.text(2))+" "+str(c)
		
		
		
		if str(item.text(3))!="":
			self.poneddlBusquedaBlanco()
		
		if str(item.text(3))=="genero":
			self.ui.ddlGenero.setCurrentIndex(self.campos.generos_id[int(item.text(2))])
		if str(item.text(3))=="tipo":
			self.ui.ddlTipo.setCurrentIndex(self.campos.tipos_id[int(item.text(2))])
		if str(item.text(3))=="formato":
			self.ui.ddlFormato.setCurrentIndex(self.campos.formatos_id[int(item.text(2))])
		if str(item.text(3))=="localizacion":
			self.ui.ddlLocalizacion.setCurrentIndex(self.campos.localizaciones_id[int(item.text(2))])
		if str(item.text(3))=="valoracion":
			self.ui.ddlValoracion.setCurrentIndex(int(item.text(0))+1)
		if str(item.text(3))=="anio":
			self.ui.ddlAnio.setCurrentIndex(int(item.text(2))+1)
		if str(item.text(3))!="":
			self.pintaTablaCatalogo(1)
		#except:
			#print "Error"
		return

	def tbResultados_onclick(self, row, col):
		#print "Se ha pulsado doble click sobre la fila "+str(row)+" columna "+str(col)
		#print " que corresponde con la pelicula id = "+str(self.peliculas[row])
		
		if (row < 0 ) or ( col < 0): return
		self.frm_insertar = insertar()
		self.frm_insertar.dbconn = self.dbconn
		self.frm_insertar.cargar(self,self.peliculas[row])
		
		#self.frminsertar.show()
		#self.frminsertar.dbconn = self.dbconn
		#self.frminsertar.cargar(self,self.peliculas[row])

	def acercade(self):
		self.frm_about = about()
		self.frm_about.version(version)
		self.frm_about.show()
		return

	def ayudabasedatos(self):
		return

	def importar(self):
		return

	def exportar(self):
		return

	def aplicaidioma(self):
		return

	def cambiaridioma(self):
		return

	def acercadeqt(self):
		QtGui.QMessageBox.aboutQt(self,self.__tr("Acerca de Qt"))
		return

	def verBarraHerramientasClick(self, status):
		self.ui.Toolbar.setHidden(not status)
		self.conf.GuardaConfiguracion('toolbar', int(status), 'vista')
		self.conf.GuardarFichero()
		return

	def verBusquedaClick(self, status):
		self.ui.groupBox1.setHidden(not status)
		self.conf.GuardaConfiguracion('search', int(status), 'vista')
		self.conf.GuardarFichero()
		return

	def verCatalogoClick(self, status):
		self.ui.treeWidget.setHidden(not status)
		self.conf.GuardaConfiguracion('catalog', int(status), 'vista')
		self.conf.GuardarFichero()
		return

	def verAccionesRapidasClick(self, status):
		self.ui.fraBotonesRapidos.setHidden(not status)
		self.conf.GuardaConfiguracion('buttons', int(status), 'vista')
		self.conf.GuardarFichero()
		return

	def asistenteConfInicial(self):
		self.frm_confinicial = confinicial()
		self.frm_confinicial.show()
		return

	def asistenteImportExport(self):
		return

	def __tr(self, texto):
		return QtGui.QApplication.translate("frmsmoviedb", texto, None, QtGui.QApplication.UnicodeUTF8)

	def codifica(self,texto):
		if self.dbtype=='mysql':
			return str(texto.toLatin1())
		else:
			return str(texto.toUtf8())
		
		


def main():
	
	app = QtGui.QApplication(sys.argv)
	#Creamos una instancia de nuestro formulario
	frm = frmMovie()

	#Mostramos el formulario
	frm.show()
	frm.conectado = 0
	frm.aplicaidioma()



	sys.exit(app.exec_())
	return 0


#Ejecutamos Main
main()
